/* swap() on non-neighbor elements around first and last */
#include "common_gadl.h"
int main()
{
	item_t *a, *b;

	list1 = gadl_list_init(NULL, sizeof(item_t), NULL, NULL);
	init_fill(list1, 6);
	dump_list(list1, "init");

	a = gadl_nth(list1, 0);
	b = gadl_nth(list1, 3);
	gadl_swap(a, b);
	dump_list(list1, "swap 0-3");

	a = gadl_nth(list1, 3);
	b = gadl_nth(list1, 0);
	gadl_swap(a, b);
	dump_list(list1, "swap 3-0");

	a = gadl_nth(list1, 3);
	b = gadl_nth(list1, 5);
	gadl_swap(a, b);
	dump_list(list1, "swap 3-5");

	a = gadl_nth(list1, 5);
	b = gadl_nth(list1, 3);
	gadl_swap(a, b);
	dump_list(list1, "swap 5-3");

	a = gadl_nth(list1, 0);
	b = gadl_nth(list1, 5);
	gadl_swap(a, b);
	dump_list(list1, "swap 0-5");

	a = gadl_nth(list1, 5);
	b = gadl_nth(list1, 0);
	gadl_swap(a, b);
	dump_list(list1, "swap 5-0");

	return 0;
}
